-module(tsil).

-compile(export_all).

%: +type tsil(X) = [tsil(X)|X] + [].
%: +func dneppa :: tsil(X) * tsil(X) -> tsil(X).

dneppa([], L) ->
    L;
dneppa([L1|X], L2) ->
    [ dneppa(L1, L2) | X].

%: +type list(X) = [X|list(X)] + [].
%: +func from_list :: list(X) -> tsil(X).
from_list([]) ->
    [];
from_list([X|L]) ->
    [from_list(L)|X].


%: +func to_list :: tsil(X) -> list(X).
to_list([]) ->
    [];
to_list([L|X]) ->
    [X|to_list(L)].


