-module(run_all).

-compile(export_all).

all([], _, _) ->
    true;
all([M|L], Path, Flags) ->
    US = use_spec([io, io_lib, ordsets, gb_trees, gb_sets]),
    {success, _} = poly:top(M, ["../src"]++Path, 
			    [prefer_spec, time]++US++Flags),
    all(L, Path, Flags).

foo([]) ->
    true.

files() ->
    [agenda, con, convert, debug_filter, filter, graph,
     poly, pos, program, reach, record_expand, sanity,
     scfa_file, rfilter, sfilter, solver, walker, worklist].

run_simp(Path) -> 
    L = files(),
    io:format("~n *** Simplify ***~n", []),
    all(L, Path, [simplify]).

run_no_simp(Path) -> 
    L = files(),
    io:format("~n *** No Simplify ***~n", []),
    all(L, Path, []).

run_reach(Path) -> 
    L = files(),
    io:format("~n *** Simplify reachablilty, not stability***~n", []),
    all(L, Path, [simplify, nostable]).

%%%%

use_spec(L) ->
    [{use_spec, F} || F<- L].

all_deep([], _, _) ->
    true;
all_deep([M|L], Path, Flags) ->
    US = use_spec([io, io_lib, ordsets, gb_trees, gb_sets, 
                   scfa_epp, scfa_io, scfa_erl_scan]),
    {success, _} =
	poly:top(M, ["../src"]++Path, 
		 [time]++US++Flags--[{use_spec, M}]),
    all_deep(L, Path, Flags).

run_deep_simp(Path) ->
    io:format("~n *** Use defs: Simplify ***~n", []),
    L = files(),
    US = use_spec(L),
    all_deep(L, Path, [simplify]).
    
run_deep_no_simp(Path) ->
    io:format("~n *** Use defs: No Simplify ***~n", []),
    L = files(),
    US = use_spec(L),
    all_deep(L, Path, []++US).

run_deep_reach(Path) ->
    io:format("~n *** Use defs: Simplify reachablilty, not stability***~n", []),
    L = files(),
    US = use_spec(L),
    all_deep(L, Path, [simplify, nostable]++US).


% The specials. (This code is awful, I know.)

run_deep_simp_specials(Path) ->
    io:format("~n *** Use defs: Simplify ***~n", []),
    L = files_specials(),
    US = use_spec(L),
    all_deep(L, Path, [simplify]++US).
    
run_deep_no_simp_specials(Path) ->
    io:format("~n *** Use defs: No Simplify ***~n", []),
    L = files_specials(),
    US = use_spec(L),
    all_deep(L, Path, []++US).

run_deep_reach_specials(Path) ->
    io:format("~n *** Use defs: Simplify reachablilty, not stability***~n", []),
    L = files_specials(),
    US = use_spec(L),
    all_deep(L, Path, [simplify, nostable]++US).

files_specials() ->
    [ordsets, gb_trees].
