-module(my_sets).

%-compile(export_all).
-export([empty/0, add/2, is_member/2, from_list/1, to_list/1, union/2]).

%: +type set(E) = map(E, erlang:bool()). 

empty() ->
    maps:new().

add(E, S) ->
    maps:put(E, true, S).

is_member(E, S) ->
    maps:is_key(E, S).

from_list(L) -> maps:from_list([{V, true} || V <- L]).

to_list(L) -> maps:keys(L).

union(S1, S2) ->
    union_1(maps:keys(S1), S2).

union_1([], S) ->
    S;
union_1([V|S1], S2) ->
    union_1(S1, maps:put(V, true, S2)).



