-module(pos).

-export([pos_zero/0, left/1, right/1, pos_list/2, name/1]).

%: +type list(X) = erlang:list(X).
%: +opaque pos() = integer().

% Positions

%: +func pos_zero :: () -> pos().		       
pos_zero() ->
    1.
%: +func left :: pos() -> pos().		   
left(P) ->
    P*2.

%: +func right :: pos() -> pos().		   
right(P) ->
    P*2+1.

%: +func pos_list :: integer() * pos() -> list(pos()).
pos_list(1, Pos) ->
    [Pos];
pos_list(N, Pos) when N > 1 ->
    [left(Pos)|pos_list(N-1, right(Pos))].

%: +func name :: pos() -> erlang:string().

name(Pos) ->
    integer_to_list(Pos).
