-module(test_scfa).

-compile(export_all).

goodies() ->
    [g004, g005, g006, g007, g008, g009, g011, g012, g013, g014, g015, 
     g016, g017, g018, g019, g020, g021, g022, g023, g025, g027, g028, g029,
     g030, g031, g032, g033, g034, g035, g036, g037, g038, g039,
     g040, g041, g042, g043, g044, g045, g046, g047, g048, g049,
     g050, g051, g052, g053, g054, g055, g056, g057, g058,
     g060, g061, g063, g064, g065, g066, g067, 
     g070, g071, g072, g073, g074, g080, g082,
     g100, g101, g102, g103, g104, g105, g106, g107, g108, g109, g110,
     g111, g112, g113, g114, g115, g116, g117, g118, g119, g120, g121,
     g122, g123, g130, g141, g200, g201,  
     g250, g251, g255, g256, g260, g261,
     g301, g302, g303, g400, g404, g405, g500].

baddies() ->
    [b001, b002, b004, b005, b007, b008, b009, b010, b011, b012, b013, b014,
     b015, b016, b017, b018, b019,
     b020, b021, b022, b023, b030, b031, b032, b033, b034, b035, b036, 
     b037, b040, b042, b043, b044, b051, b053, b054,
     b100, b101, b102, b103, b104, b105, b106, b107, b108, b109, b110,
     b111, b112, b113, b114, b115, b116, b117, b118, b119, b120, b121,
     b122, b123, b124, b125, b126, b127, b128, b129, b130, b131, b132,
     b133, b134, b136, b137, b138, b139, b140, b141, b142, b143,
     b144, b145, b146, b147, b148, b149, b150, b151, b152, b153,
     b155, b156, b157, b158, b159, b160, b161, b162, b163, b164, b165,
     b166, b167, b168, b169, b170, b171, b173, b174, b175, b176,
     b177, b178, b179, b180, b181, b200, b250, b251, b255, b256, b260, b261,
     b301, b302].

% Make sure good tests are on path.
good(Path) -> 
    Good = goodies(),
    Options = [],
    run_all(Good, success, Path, Options),
    Options1 = [simplify],
    run_all(Good, success, Path, Options1).

% Make sure bad tests are on path.
bad(Path) ->
    Bad = baddies(),
    Options = [],
    run_all(Bad, fail, Path, Options),
    Options1 = [simplify],
    run_all(Bad, fail, Path, Options1).


% Make sure good tests are on path.
good_u(Path) -> 
    Good = goodies(),
    Options = [],
    run_all(Good, success, Path, Options).

% Make sure bad tests are on path.
bad_u(Path) ->
    Bad = baddies(),
    Options = [],
    run_all(Bad, fail, Path, Options).



run_all(Files, Flag, Path, Options) ->
    [begin
	 io:format("~nTest ~w ", [F]),
	 {Flag, _} = apply(fun poly:top/3, [F, Path, Options]) %local]]) 
     end
     || F<- Files].


good_s(Path) -> 
    Good = goodies(),
    R = run_all_s(Good, success, Path, []),
    if R == [] ->
            true;
       true ->
            io:format("~nSome tests failed: ~w", [R])
    end.

bad_s(Path) ->
    Bad = baddies(),
    R = run_all_s(Bad, fail, Path, []),
    if R == [] ->
            true;
       true ->
            io:format("~nSome programs succeeded (they should have failed): ~w", [R])
    end.

run_all_s([], _, _, R) ->
    lists:reverse(R);
run_all_s([File|Files], Flag, Path, R) ->
    io:format("~nTest ~w ", [File]),
    {Flag1, _} = apply(fun poly:top/3, [File, Path, []]),
    if Flag == Flag1 ->
            R1 = R;
       true ->
            R1 = [File|R]
    end,
    run_all_s(Files, Flag, Path, R1).



% Make sure good tests are on path.
good_o(Path, Options) -> 
    Good = goodies(),
    run_all_o(Good, success, Path, Options).

% Make sure bad tests are on path.
bad_o(Path, Options) ->
    Bad = baddies(),
    run_all_o(Bad, fail, Path, Options).


run_all_o(Files, Flag, Path, Options) ->
    [begin
	 io:format("~nTest ~w ", [F]),
	 {Flag, _} = apply(fun poly:top/3, [F, Path, Options]) 
     end
     || F<- Files].

